program BK_P1;


Type real=extended;
     TPoint=record
              x:real;
              y:real;
            end;
     TLine=record
              a:real;
              b:real;
              c:real;
           end;
     Totrez=record
              a:TPoint;
              b:TPoint;
            end;
const
   eps=1e-9;
   inf=1e+9;
   pinf:TPoint=(x:inf;y:inf);
var a,b:Totrez;
l1,l2:TLine;
Pres:TPoint;
qwerty:boolean;
q,w,e,r,t,y,u,i:integer;
label l;
procedure pline(const a,b:real; const p:TPoint;var l:TLine);
begin
  l.a:=a;
  l.b:=b;
  l.c:=-a*p.x-b*p.y;
end;
procedure P2line(const p1,p2:TPoint;var l1:TLine);
begin
  Pline(p1.y-p2.y,p2.x-p1.x,p1,l1);
end;
function eq(const a,b:real):boolean;
begin
  eq:=abs(a-b)<=eps;
end;
function det(const a,b,c,d:real):real;
begin
  det:=a*d-b*c;
end;
function l2point(const l1,l2:TLine;var p:TPoint):boolean;
var d:real;
begin
  l2point:=false;
  d:=det(l1.a,l2.a,l1.b,l2.b);
  if eq(d,0) then p:=Pinf else
    begin
      p.x:=-det(l1.c,l2.c,l1.b,l2.b)/d;
      p.y:=-det(l1.a,l2.a,l1.c,l2.c)/d;
      l2Point:=true;
    end;
end;
function ge(const a,b:real):boolean;
begin
  ge:=(a>=b)or(eq(a,b));
end;
function le(const a,b:real):boolean;
begin
  le:=(a<=b)or(eq(a,b));
end;
function Btw(const x,a,b:real):boolean;
begin
  Btw:=le(a,x) and le(x,b) or ge(a,x) and ge(x,b);
end;
function PBtw(const p,p1,p2:TPoint):boolean;
begin
  PBtw:=Btw(p.x,p1.x,p2.x) and Btw(p.y,p1.y,p2.y);
end;
procedure swap(var a,b:real);
var c:real;
begin
  c:=a;
  a:=b;
  b:=c;
end;
begin
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(input);
  rewrite(output);
  read(a.a.x,a.a.y,a.b.x,a.b.y);
 read(b.a.x,b.a.y,b.b.x,b.b.y);
  read(q,w,e,r,t,y,u,i);
  a.a.x:=q;
  a.a.y:=w;
  a.b.x:=e;
  a.b.y:=r;
  b.a.x:=t;
  b.a.y:=y;
  b.b.x:=u;
  b.b.y:=i;


  p2line(a.a,a.b,l1);
  p2line(b.a,b.b,l2);
  if not l2point(l1,l2,Pres) then
    begin
      qwerty:=false;
      l:
      if PBtw(a.a,b.a,b.b) then
        if PBtw(a.b,b.a,b.b) then
          begin
            writeln('SEGMENT ',a.a.x:0:0,' ',a.a.y:0:0,' ',a.b.x:0:0,' ',a.b.y:0:0);
            exit;
          end else
        if PBtw(b.a,a.a,a.b) then
          begin
            writeln('SEGMENT ',a.a.x:0:0,' ',a.a.y:0:0,' ',b.a.x:0:0,' ',b.a.y:0:0);
            exit;
          end else
        if PBtw(b.b,a.a,a.b) then
          begin
            writeln('SEGMENT ',a.a.x:0:0,' ',a.a.y:0:0,' ',b.b.x:0:0,' ',b.b.y:0:0);
            exit;
          end;

      if PBtw(a.b,b.a,b.b) then
        if PBtw(a.a,b.a,b.b) then
          begin
            writeln('SEGMENT ',a.a.x:0:0,' ',a.a.y:0:0,' ',a.b.x:0:0,' ',a.b.y:0:0);
            exit;
          end else
        if PBtw(b.a,a.a,a.b) then
          begin
            writeln('SEGMENT ',a.b.x:0:0,' ',a.b.y:0:0,' ',b.a.x:0:0,' ',b.a.y:0:0);
            exit;
          end else
        if PBtw(b.b,a.a,a.b) then
          begin
            writeln('SEGMENT ',a.b.x:0:0,' ',a.b.y:0:0,' ',b.b.x:0:0,' ',b.b.y:0:0);
            exit;
          end;
      if not qwerty then
        begin
          qwerty:=true;
          swap(a.a.x,b.a.x);
          swap(a.a.y,b.a.y);
          swap(a.b.x,b.b.x);
          swap(a.b.y,b.b.y);

          goto l;
        end;
      writeln('NONE');
      exit;
    end else
    begin
      if PBtw(pres,a.a,a.b) and PBtw(pres,b.a,b.b) then writeln('POINT ',pres.x:8:8,' ',pres.y:8:8) else
                                                    writeln('NONE');
    end;
  close(input);
  close(output);  
end.
